#ifndef _GPIO_H_
#define _GPIO_H_

#ifdef __cplusplus
extern "C" {
#endif


#include <stdio.h>
#include <errno.h>

#define GPIO_ROOT           "/sys/class/gpio"
#define GPIO_EXPORT_FILE    "/sys/class/gpio/export"
#define GPIO_UNEXPORT_FILE  "/sys/class/gpio/unexport"


#if defined (__aarch64__) || defined (__arch64__)
# define GLOBAL_GPIO_BASE 338   // ZynqMP
#else
# define GLOBAL_GPIO_BASE 906   // Zynq 7000
// # define GPIO_EMIO_OFFSET 54
#endif


struct struct_gpio_pin_t
{
    unsigned char pin;
    unsigned char dir;    // 0 = IN, 1 = OUT
};
typedef struct struct_gpio_pin_t gpio_pin_t;


int open_gpio_channels(int gpio_base, gpio_pin_t *gpio_channel_list, unsigned char gpio_pins);
int close_gpio_channels(int gpio_base, gpio_pin_t *gpio_channel_list, unsigned char gpio_pins);
int set_gpio_value(int gpio_base, gpio_pin_t *gpio_channel_list, int pin, int value);
int get_gpio_value(int gpio_base, gpio_pin_t *gpio_channel_list, int pin);




#ifdef __cplusplus
}
#endif


#endif
