/********************************************
 * UTIA AV CR, v.v.i
 * Signal Processing Department
 * Pod Vodarenskou vezi 4
 * 182 00 Prague
 * Czech Republic
 * web: http://zs.utia.cas.cz
 * contact: sp@utia.cz
 *
 * Filename: i2c_te.h
 * Date: 2023.01.04
 * Author: Lukas Kohout <kohoutl@utia.cas.cz>
 * Description:
 *    I2C controller init
 *
 * Changelog:
 *
 *
 *
 *
 ********************************************/


#ifndef _I2C_TE_HEADER_FILE_
#define _I2C_TE_HEADER_FILE_

#ifdef __cplusplus
extern "C" {
#endif


#define TE_I2C_SLAVE_FORCE    0x0706
#define TE_I2C_SLAVE          0x0703  /* Change slave address */
#define TE_I2C_FUNCS          0x0705  /* Get the adapter functionality */
#define TE_I2C_RDWR           0x0707  /* Combined R/W transfer (one stop only) */



int i2c_te_write(int i2c_fd, unsigned char dev_addr, unsigned char reg, unsigned char data);
int i2c_te_read(int i2c_fd, unsigned char dev_addr, unsigned char reg);
int i2c_te_init(char *i2c_device);
void i2c_te_deinit(int *i2c_fd);


#ifdef __cplusplus
}
#endif

#endif
